unit example;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,Math, ExtCtrls, formula;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button3: TButton;
    formula1: tformula;
    Button2: TButton;
    Button4: TButton;
    Button5: TButton;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure formula1ValidateParameter(Sender: TObject; Parameter: string;
      var Valid: Boolean);
    procedure formula1GetParameterValue(Sender: TObject; Parameter: string;
      var Value: extended);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;


type
    tformuladescendant = class(tformula)
     private
       procedure NRoot;
     public
       constructor Create(AOwner:TComponent);override;
     end;



var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure tformuladescendant.NRoot;
var y : extended;
begin
   y:=PopValue;
   PushValue(Power(y,1/PopValue));
end;

constructor tformuladescendant.Create(AOwner:TComponent);
begin
   inherited Create(AOwner);
   RegisterFunction('NRoot',2,'Parameters a,b : return a.th root of b.',NRoot);
end;

procedure TForm1.Button1Click(Sender: TObject);
var TF : TFormulaError;
    x : extended;
    st : TStringList;
    i : LongInt;
    txt : AnsiString;
begin
     MessageDlg('the memo-box is now being filled with the original functions of tformula.',mtinformation,[mbok],0);
     st:=TStringList.Create;
     Formula1.GetFunctionList(st);
     Memo1.Lines:=st;
     St.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
var Error : TFormulaError;
    t : extended;
    txt : AnsiString;
begin
   Formula1.Formula:='NoverK(N,K)';
   Formula1.Parameters.Clear;
   Formula1.Parameters.Add('n');
   Formula1.Parameters.Add('k');
   Error:=Formula1.InitFormula;
   If Error.Code<>0 then
   begin
      MessageDlg(Formula1.Formula+#13#10+inttostr(Error.Position)+#13#10+Error.Text,mtError,[mbok],0);
   end else
   begin
      txt:='If you play a lottery where you take six balls'+#13#10+
           'out of a bowl with 49 numbered balls, how many'+#13#10+
           'different variations do exist ?'+#13#10+'(order not important)'+#13#10#13#10+
           'answer : NoverK(49,6) = '+FloatToStrF(

           Formula1.Calculate([49,6])

           ,ffFixed,20,0)+#13#10#13#10#13#10+
           'What is the probability that you can tell the right'+#13#10+'six balls in one guess ?'+#13#10#13#10+
           'answer : 1/NoverK(49,6) = '+FloatToStrF(

           1/Formula1.Calculate([49,6])

           ,ffFixed,20,15)+#13#10;
      MessageDlg(txt,mtInformation,[mbok],0);
   end;
end;

procedure TForm1.formula1ValidateParameter(Sender: TObject;
  Parameter: string; var Valid: Boolean);
begin
     valid:=true;
end;

procedure TForm1.formula1GetParameterValue(Sender: TObject;
  Parameter: string; var Value: extended);
begin
   case Parameter[1] of
    'N' : Value:=49;
    'K' : Value:=6;
   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var f : tformuladescendant;
    st : TStringList;
    t : extended;
begin
   MessageDLG('We now create a descendant of TFormula, which adds a new function'+#13#10+
              'NROOT to the function-list. The memobox will then be filled with'+#13#10+
              'the functions of the descendant.',mtInformation,[mbok],0);
   f:=tformuladescendant.Create(Self);
   st:=TStringList.Create;
   F.GetFunctionList(st);
   Memo1.Lines:=st;
   St.Free;
   f.Formula:='nroot(3,8)';
   Messagedlg('We now calculate the 3rd root of 8 using TFormuladescendant :'+#13#10#13#10+
              'Nroot(3,8) = '+floattostrf(f.Calculate2,ffGeneral,20,4),mtinformation,[mbok],0);
   f.Free;
end;

procedure TForm1.Button4Click(Sender: TObject);
var t : extended;
begin
   Formula1.Formula:='fak(x)';
   Formula1.Parameters.Clear;
   Formula1.Parameters.Add('x');
   Formula1.InitFormula;
   t:=Formula1.Calculate([1754]);
   MessageDlg('We now calculate the faculty of 1754 (1754!) :'+#13#10#13#10+
              'Fak(1754) = '+FloatToStrF(t,ffFixed,100,0),mtInformation,[mbok],0);
end;

procedure TForm1.Button5Click(Sender: TObject);
var i : Word;
begin
   if MessageDlg('We now calculate the faculties of 1 through 1754, displaying'+#13#10+
              'the results in the PANEL below.'+#13#10#13#10+
              'Hit OK to start.',mtInformation,[mbok,mbCancel],0)=mrOK then
   begin
      Formula1.Formula:='fak(x)';
      Formula1.Parameters.Clear;
      Formula1.Parameters.Add('x');
      Formula1.InitFormula;
      Screen.Cursor:=crHourGlass;
      For i:=1 to 1754 do
      begin
         Panel1.Caption:='Fak('+IntToStr(i)+') = '+FloatToStrF(Formula1.Calculate([i]),ffGeneral,20,20);
         Panel1.Refresh;
      end;
      Screen.Cursor:=crArrow;
   end;
end;

end.
